import os
import re
import errno
import itertools
from datetime import datetime
from mkdocs.plugins import BasePlugin

from mkdocs.config import config_options, Config
from mkdocs.structure.files import Files, File
from mkdocs.utils import nest_paths
from mkdocs.structure.nav import Navigation, Section, Page, \
    _get_by_type, _add_parent_links, _data_to_navigation

# Files need to be in YYYYMMDD.md format, on the root of the configured path for autogeneration,
# i.e. updates/c8/20200101.md
FILE_NAME_REGEX = re.compile(r'.+\/(\d*)\.md')
SOURCE_FILES = []


#Expected config looks like this:
"""
plugins:
  - updates-autogeneration-plugin:
      autogenerate_path:
        - AUTOGENERATE_C8_PROD:
            section_name: Production
            path: updates/c8/prod/
            # This template will be used for the latest_updates.md final result. It is optional
            template_path: updates/prod.tpl
        - AUTOGENERATE_C8_TEST:
            section_name: Testing
            path: updates/c8/test/
            # This template will be used for the latest_updates.md final result. It is optional
            template_path: updates/test.tpl
            # URL and title for the latest updates section. It is optional.
            latest_section_url: 'latest_updates'
            latest_section_title: 'Latest updates'
            # URL and title for the monthly updates section. It is optional.
            monthly_section_url: 'monthly_updates'
            monthly_section_title: 'updates'
            # Number of latest updates to show. It is optional.
	        latest_count: 4
            # Whether to show all updates in the latest updates section. It is optional.
            latest_shows_all: false
            # Generate a single page only with the latest updates, don't generate the chronological pages. It is optional.
            generate_single_page: false
      autogenerate_sitemap: true
  - search:
"""


class UpdatesAutogenerationPlugin(BasePlugin):

    config_scheme = (
        ('autogenerate_path', config_options.Type(list, default=[])),
        ('autogenerate_sitemap', config_options.Type(bool, default=False)),
    )

    # Returns a new section for updates
    @staticmethod
    def build_section_updates(self, section_plugin_config, config, files):
        file_dates_to_order = []
        # Pages that need nav autogeneration belong to the config path and have no Page, reduce search to previously filtered list
        for file in SOURCE_FILES:
            # This is the case for nav items not present on nav config.
            # These files require autogeneration as belong to the autogeneration path
            if file.page is None and file.url.startswith(section_plugin_config['path']):
                file_date_match = FILE_NAME_REGEX.match(file.src_path)
                if file_date_match is None:
                    continue
                elif file_date_match.group(1):
                    # File names are in format YYYYMMDD
                    date_to_organise = datetime.strptime(file_date_match.group(1), "%Y%m%d")
                    # [0] Name [1] datetime [2] file handler
                    file_dates_to_order.append([file_date_match.group(1), date_to_organise, file])
                else:
                    continue

        # This list is grouped by year and then month, from last to first to always check latest first
        file_dates_to_order_reversed = sorted(file_dates_to_order, key=lambda i: i[1].strftime("%Y%m%d"), reverse=True)
        grouped_list = [[list(subgroup) for _, subgroup in itertools.groupby(group, key=lambda i: i[1].strftime("%m"))]
                        for _, group in itertools.groupby(file_dates_to_order_reversed, key=lambda i: i[1].strftime("%Y"))]

        latest_page = self.build_last_updates(self, section_plugin_config, config, files, file_dates_to_order_reversed)

        generate_single_page = bool(section_plugin_config.get("generate_single_page", False))
        if generate_single_page:
            return latest_page

        # Section where we add our autogenerated content
        built_section = Section(title=section_plugin_config['section_name'], children=[])

        # We add a "Latest updates" Page as the first item of the year
        built_section.children.append(latest_page)

        # We order years from last to first
        for year in grouped_list:
            # First level is months, then first month, then datetime to extract year
            year_title = year[0][0][1].strftime("%Y")
            year_section = Section(title=year_title, children=[])
            built_section.children.append(year_section)

            # Build month from Dec to Jan
            for month in year:
                month_title = month[0][1].strftime("%B")
                month_numeric = month[0][1].strftime("%m")

                # This markdown File has the combined result of all monthly updates, concat in a single file
                combined_file_path = os.path.join(section_plugin_config['path'],
                                                  year_title, month_numeric, section_plugin_config.get("monthly_section_url", "monthly_updates") + ".md")

                docs_combined_file_path = os.path.join(config['docs_dir'], combined_file_path)
                if not os.path.exists(os.path.dirname(docs_combined_file_path)):
                    try:
                        os.makedirs(os.path.dirname(docs_combined_file_path))
                    except OSError as exc:  # Guard against race condition
                        if exc.errno != errno.EEXIST:
                            raise
                file_handler_combined = open(docs_combined_file_path, "w")

                file_to_add = File(combined_file_path, config['docs_dir'], config['site_dir'], config['use_directory_urls'])
                # We need to add this file to the complete list so mkdocs generates html files for it
                files.append(file_to_add)

                # Add monthly page with combined updates
                month_page = Page(month_title, file_to_add, config)
                year_section.children.append(month_page)
                if len(month) == 0:
                    continue
                # We need to add a header for the combined result, not depend on input update files, otherwise the table of contents does not build
                file_handler_combined.write(f"# {month_title} {section_plugin_config.get('monthly_section_title', 'updates')}\n")

                for update in month:
                    # Reading data from file1
                    file_handler = update[2]
                    with open(os.path.join(os.getcwd(), config['docs_dir'], file_handler.src_path)) as fp:
                        data = fp.read()
                    file_handler_combined.write("\n")
                    file_handler_combined.write(data)
                    fp.close()
                file_handler_combined.close()

        return built_section

    @staticmethod
    def build_last_updates(self, section_plugin_config, config, files, file_dates):

        # This markdown File has the combined result of all monthly updates, concat in a single file
        combined_file_path = os.path.join(section_plugin_config['path'], section_plugin_config.get("latest_section_url", "latest_updates") + ".md")

        docs_combined_file_path = os.path.join(config['docs_dir'], combined_file_path)
        if not os.path.exists(os.path.dirname(docs_combined_file_path)):
            try:
                os.makedirs(os.path.dirname(docs_combined_file_path))
            except OSError as exc:  # Guard against race condition
                if exc.errno != errno.EEXIST:
                    raise

        file_handler_combined = open(docs_combined_file_path, "w")

        file_to_add = File(combined_file_path, config['docs_dir'], config['site_dir'], config['use_directory_urls'])
        # We need to add this file to the complete list so mkdocs generates html files for it
        files.append(file_to_add)

        # Add the last updates page with combined updates
        last_updates_page = Page(section_plugin_config.get("latest_section_title", "Latest updates"), file_to_add, config)

        # Use template for updates page if it exists, fallback to a simple header if not
        if "template_path" in section_plugin_config and os.path.exists(os.path.join(os.getcwd(), config['docs_dir'], section_plugin_config['template_path'])):
            # Use template_path file as the begginning of the Latest updates page
            with open(os.path.join(os.getcwd(), config['docs_dir'], section_plugin_config['template_path'])) as fp:
                data = fp.read()
            file_handler_combined.write(data)
        else:
            # We need to add a header for the combined result or TOC won't build
            file_handler_combined.write(f"# {section_plugin_config.get('latest_section_title', 'Latest updates')}\n")

        latest_shows_all = bool(section_plugin_config.get("latest_shows_all", False))
        if not latest_shows_all:
            # Last updates page will only show the 4 latest update dates (by default, can be configured)
            latest_count = int(section_plugin_config.get("latest_count", 4))
            file_dates = file_dates[:latest_count]

        for file_date in file_dates:
            # Reading data from file
            file_handler = file_date[2]
            with open(os.path.join(os.getcwd(), config['docs_dir'], file_handler.src_path)) as fp:
                data = fp.read()
            file_handler_combined.write("\n")
            file_handler_combined.write(data)

            update_title = file_date[1].strftime("%d")
            fp.close()

        file_handler_combined.close()

        return last_updates_page

    def _process_nav_items_recursive(self, nav_items, plugin_config, config, files):
        new_nav_items = []
        # Build a temp list to use for retrieving the corresponding config for a section
        to_generate=[list(entry.keys())[0] for entry in plugin_config['autogenerate_path']]
        for nav_item in nav_items:
            if nav_item.is_section:
                # If there is more than one child, we want to recurse over them so that
                # we can collapse folders of single pages at any depth in the tree.
                nav_item.children = (self._process_nav_items_recursive(nav_item.children, plugin_config, config, files))
                new_nav_items.append(nav_item)

            else:
                # No child items, just add this directly.
                if(nav_item.is_link and nav_item.url in to_generate):
                    # We need to pass the section config to the next function
                    config_index=to_generate.index(nav_item.url)
                    # Extract dict to pass to section building, it needs some type transformation to extract the dict inside the config option index
                    section_plugin_config = list(plugin_config['autogenerate_path'][config_index].values())[0]
                    # Replace useless link with real nav, split by months, and with a summary of latest updates for root section
                    new_nav_items.append(self.build_section_updates(self, section_plugin_config, config, files))
                else:
                    new_nav_items.append(nav_item)

        return new_nav_items

    # Produce recursively a sitemap page
    def _process_nav_items_recursive_sitemap(self, nav_items, plugin_config, config, files, file_handler_sitemap, entry_level):
        for nav_item in nav_items:
            # Add a multiple of 4 spaces, as some parsers do not work well with 2 space indentation
            level = entry_level * "    " + "* "
            entry_level_next = entry_level + 1
            if nav_item.is_section:
                file_handler_sitemap.write("%s%s\n" % (level, str(nav_item.title)))
                self._process_nav_items_recursive_sitemap(nav_item.children, plugin_config, config, files, file_handler_sitemap, entry_level_next)
            else:
                file_handler_sitemap.write("%s[/%s](/%s)\n" % (level, str(nav_item.url), str(nav_item.url)))

    def generate_sitemap_page(self, files, plugin_config, config):
        nav_config = nest_paths(f.src_path for f in files.documentation_pages())
        items = _data_to_navigation(nav_config, files, config)
        pages = _get_by_type(items, Page)
        nav = Navigation(items, pages)

        # This markdown File has the sitemap with all pages, even if not present on the nav
        sitemap_file_path = os.path.join("sitemap", "index.md")
        docs_sitemap_file_path = os.path.join(config['docs_dir'], sitemap_file_path)
        if not os.path.exists(os.path.dirname(docs_sitemap_file_path)):
            try:
                os.makedirs(os.path.dirname(docs_sitemap_file_path))
            except OSError as exc:  # Guard against race condition
                if exc.errno != errno.EEXIST:
                    raise
        file_handler_sitemap = open(docs_sitemap_file_path, "w")
        file_sitemap = File(sitemap_file_path, config['docs_dir'], config['site_dir'], config['use_directory_urls'])
        file_handler_sitemap.write("# Sitemap\n")
        entry_level = 0
        self._process_nav_items_recursive_sitemap(nav, self.config, config, files, file_handler_sitemap, entry_level)

        return file_sitemap

    # After a build, we should regenerate our nav according to the provided .md files.
    def on_nav(self, nav: Navigation, config: Config, files: Files):
        # Generate new nav based on the config['nav'] plus autogenerate the specified path
        nav.items = self._process_nav_items_recursive(nav, self.config, config, files)

        # This part is necessary for nav breadcrumbs to be visible
        pages = _get_by_type(nav.items, Page)
        _add_previous_and_next_links(pages, self.config)
        _add_parent_links(nav.items)
        return Navigation(nav.items, pages)

    # We alter files to be processed to reduce building time, and more important, to remove them from download paths
    def on_files(self, files, config: Config):

        # Used to control what files we exclude from files processing
        to_generate_paths = tuple(list(entry.values())[0]['path'] for entry in self.config['autogenerate_path'])
        # This needs all files in config plus those that we build ourselves, that will come on nav creation
        result_files = []
        # Filter files that belong to the autogeneration paths
        filtered = [file for file in files if file.src_path.startswith(to_generate_paths)]
        # Excluding files
        for file in files:
            if file in filtered:
                file_date_match = FILE_NAME_REGEX.match(file.src_path)
                if file_date_match is None:
                    result_files.append(file)
                elif file_date_match.group(1):
                    # Do not include this file, but save it for later processing
                    SOURCE_FILES.append(file)
                else:
                    result_files.append(file)
            else:
                result_files.append(file)

        # We can autogenerate a sitemap with ALL pages, no matter they do not appear on the configured nav
        if self.config['autogenerate_sitemap']:
            result_files.append(self.generate_sitemap_page(Files(result_files), self.config, config))

        return Files(result_files)

def get_regexmatch_or_default(page, type_list):
    try:
        for t in type_list:
            if page.url.endswith(f"/{t}/"):
                return True
    except (AttributeError):
        pass
    return None

# We use our custom function to invert footer links when dealing with autogenerated pages,
# otherwise next and previous links point to ilogical pages according to the natural month order
def _add_previous_and_next_links(pages, config):
    # Used to control which pages need adjustments on footer links
    to_generate_paths = tuple(list(entry.values())[0]['path'] for entry in config['autogenerate_path'])
    type_list = set(list(entry.values())[0].get('latest_section_url', 'latest_updates') for entry in config['autogenerate_path'])
    filtered = [page for page in pages if page.url.startswith(to_generate_paths)]
    bookended = [None] + pages + [None]
    zipped = zip(bookended[:-2], bookended[1:-1], bookended[2:])
    for page0, page1, page2 in zipped:
        if page1 in filtered:
            # Matches will be None if they do not need to be excluded
            page_exclude_match0 = get_regexmatch_or_default(page0, type_list)
            page_exclude_match1 = get_regexmatch_or_default(page1, type_list)
            page_exclude_match2 = get_regexmatch_or_default(page2, type_list)
            # Do not add links for those pages matching the regexr
            if page_exclude_match1 is None:
                if page_exclude_match0 is None and page_exclude_match2 is None:
                    page1.previous_page, page1.next_page = page2, page0
                elif page_exclude_match0 is not None and page_exclude_match2 is None:
                    page1.previous_page, page1.next_page = page2, None
                elif page_exclude_match0 is None and page_exclude_match2 is not None:
                    page1.previous_page, page1.next_page = None, page0
                elif page_exclude_match0 is not None and page_exclude_match2 is not None:
                    page1.previous_page, page1.next_page = None, None
        else:
            page1.previous_page, page1.next_page = page0, page2
